<template>
  <div>
    <v-card class="pl-6 pr-6 pb-5 pt-2">
      <v-card-title class="pb-0">
        <h1>
          <b v-if="compra">{{$t('editarCompra')}}</b>
          <b v-else>{{$t('nuevaCompra')}}</b>
        </h1>
      </v-card-title>
      <v-form v-model="valid" ref="compraFrom" class="pb-4 pt-4">
        <v-row>
          <v-col cols="12" lg="3" md="3" sm="12" class="mt-3">
            <v-text-field
              v-model="form.factura"
              :rules="rules.isRequired"
              dense
              :label="$t('factura')"
              :disabled="disabled"
            />
          </v-col>
          <v-col cols="12" lg="4" md="4" sm="12" class="mt-0 pt-0">
            <ProveedoresBuscador
              class="pt-6"
              @onSeleccionarProveedor="proveedorSeleccionado"
            />
          </v-col>
          <v-col cols="12" lg="5" md="5" sm="12">
            <h3 v-if="disabled">
              <span class="success--text">{{ $t('codigoGenerado') }} {{ ' : ' }} {{ codigo }}</span>
            </h3>
          </v-col>
        </v-row>
      </v-form>
      <v-card-actions>
        <v-row>
          <v-btn
            color="accent"
            rounded
            @click="guardarCompra"
            :disabled="disabled"
          >
            {{$t('guardar')}}
          </v-btn>
          <v-btn text color="error" rounded @click="cancelarGuardar">
            {{$t('cancelar')}}
          </v-btn>
          <v-btn text color="error" rounded @click="terminarCompra">
            {{$t('terminar')}}
          </v-btn>
          <br/>
        </v-row>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script>
import CompraServicio from '@/store/services/CompraServicio'
import ProveedoresBuscador from '../Proveedores/ProveedoresBuscador'
export default {
  name:'ComprasForm',
  components: {
    ProveedoresBuscador
  },
  props: {
    compra: {
      type: Object,
      required: false,
      default: null
    }
  },
  data () {
    return {
      valid: false,
      form: {
        id: null,
        factura: '',
        proveedor_id: ''
      },
      rules: {
        isRequired: [value => !!value || this.$t('errorAlCargar')],
      },
      isLoading: false,
      disabled: false,
      codigo: 0
    }
  },
  methods: {
    async guardarCompra() {
      try {
        if (this.$refs.compraFrom.validate()) {
          var response = ''
          if (!this.form.id || this.form.id === '') {
            let dataForm = new FormData()
            for (let key in this.form) {
              dataForm.append(key, this.form[key])
            }
            response = await CompraServicio.create(dataForm)
          } else {
            response = await CompraServicio.update(this.form.id, this.form)
          }
          this.disabled = true
          this.codigo = response.data.id
          this.$emit('onCompraGuardada', response.data)
        }
      } catch (e) {console.log(e)
        if (e.response.status > 300) {
          console.log('error compra')
        }
      }
    },
    cancelarGuardar() {
      this.$refs.compraFrom.reset()
      this.$emit('onCancelarGuardar',  false);
    },
    setData() {
      if (this.compra) {
        this.form.id = this.compra.id
        this.form.factura = this.compra.factura
      }
    },
    resetData() {
      this.form.id = null
      this.form.factura = ''
      this.codigo = 0
      this.disabled = false
    },
    terminarCompra() {
      this.resetData()
      this.$emit('onTerminarCompra')
    },
    proveedorSeleccionado(value) {
      this.form.proveedor_id = value.id
    }
  },
  computed: {

  },
  watch: {
    compra() {
      this.setData()
    }
  },
  created() {
    this.setData()
  }
}
</script>

<style>

</style>
